## libgmpada 0.0.20120331

=== Makefile ===
#    GMPAda, binding to the Ada Language for the GNU MultiPrecision library.
#    Copyright (C) 2007-2012 Nicolas Boulenguez <nicolas.boulenguez@free.fr>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

########################
# Global configuration #
########################

LIB_NAME := gmpada

SOVERSION := 2

################################
# Build and test configuration #
################################

# Use environment variables if available, this is common practice for
# CFLAGS and LDFLAGS.
CFLAGS   ?= -O2
ADAFLAGS ?= -O2
LDFLAGS  ?=

.NOTPARALLEL:
GPRBUILD_OPTIONS := -j$(shell getconf _NPROCESSORS_ONLN)

ifdef ALL_CHECKS
  CFLAGS += -Wall -Wextra -Wformat -Wformat-security -g
  ADAFLAGS += -Wall -Wextra -g -gnatE -gnatQ -gnatVa -gnata -gnatf	\
  -gnato -gnatq -gnatySdouxy
  GPRBUILD_OPTIONS += -s -we
endif

# We want the same compiler for generate_constants.c and the library.
CC := gnatgcc

##############################
# Installation configuration #
##############################

# Each of the following path should be prefixed with
DESTDIR :=

# The sources files are installed into a LIB_NAME subdirectory of
SRC_DIR := usr/share/ada/adainclude

# A LIB_NAME.gpr project convenient for library usage is installed into
GPR_DIR := usr/share/ada/adainclude
# The content of this file ignores DESTDIR.

# The GNAT ALI files are installed into a LIB_NAME subdirectory of
ALI_DIR := usr/lib/ada/adalib

# The static and dynamic library are installed into
LIB_DIR := usr/lib

#########
# Rules #
#########

# Function exporting a variable on the command line.
to_X_options = $(foreach var,$(1),-X$(var)="$($(var))")

build: build-dynamic build-static

build-dynamic build-static: build-%: src/gmp-constants.ads
	gprbuild $(LIB_NAME).gpr $(GPRBUILD_OPTIONS) -XKIND=$* $(call to_X_options,\
          ADAFLAGS CFLAGS LDFLAGS SOVERSION)

clean::
	rm -f $(foreach dir,obj lib,$(foreach kind,dynamic static,build-$(dir)-$(kind)/*))

src/gmp-constants.ads: generate_constants
	./$< > $@
clean::
	rm -f src/gmp-constants.ads

generate_constants: LDLIBS := -lgmp
clean::
	rm -f generate_constants

clean::
	find -name "*~" -delete

test: build-static
	gprbuild demo/demo.gpr $(GPRBUILD_OPTIONS) -XKIND=static $(call to_X_options,\
          ADAFLAGS CFLAGS LDFLAGS)
	demo/demo
# Gmpada.gpr is found in the current directory when executing this
# recipe, and will be found in the default system location after
# installation.
clean::
	gprclean -q demo/demo.gpr -XKIND=static

install: build
	install --directory $(DESTDIR)/$(SRC_DIR)/$(LIB_NAME)
	install --mode=644 src/*.ad[sb] src/*.[ch] $(DESTDIR)/$(SRC_DIR)/$(LIB_NAME)
	install --directory $(DESTDIR)/$(GPR_DIR)
	sed template_for_installed_project \
          $(foreach var,LIB_NAME SRC_DIR ALI_DIR LIB_DIR,-e 's|$$($(var))|$($(var))|g') \
          > $(DESTDIR)/$(GPR_DIR)/$(LIB_NAME).gpr
	chmod 644 $(DESTDIR)/$(GPR_DIR)/$(LIB_NAME).gpr
	install --directory $(DESTDIR)/$(ALI_DIR)/$(LIB_NAME)
	install --mode=444 build-lib-dynamic/*.ali $(DESTDIR)/$(ALI_DIR)/$(LIB_NAME)
	install --directory $(DESTDIR)/$(LIB_DIR)
	install --mode=644 build-lib-static/lib$(LIB_NAME).a $(DESTDIR)/$(LIB_DIR)
	install --mode=644 build-lib-dynamic/lib$(LIB_NAME).so.$(SOVERSION) $(DESTDIR)/$(LIB_DIR)
	cd $(DESTDIR)/$(LIB_DIR) && ln --force --symbolic lib$(LIB_NAME).so.$(SOVERSION) lib$(LIB_NAME).so

uninstall:
	rm -rf $(DESTDIR)/$(SRC_DIR)/$(LIB_NAME)
	rm -f $(DESTDIR)/$(GPR_DIR)/$(LIB_NAME).gpr
	rm -rf $(DESTDIR)/$(ALI_DIR)/$(LIB_NAME)
	rm -f $(DESTDIR)/$(LIB_DIR)/lib$(LIB_NAME).a
	rm -f $(DESTDIR)/$(LIB_DIR)/lib$(LIB_NAME).so.$(SOVERSION)
	rm -f $(DESTDIR)/$(LIB_DIR)/lib$(LIB_NAME).so

.PHONY: build build-dynamic build-static clean install test uninstall

=== debian/changelog ===
libgmpada (0.0.20120331-1) unstable; urgency=low

  * New upstream release (neither ALI nor SO changes).
  * watch: search for bz2 tarballs too.
  * control: -dbg does not Pre-Depends: ${misc:Pre-Depends} for multiarch.
    -dev Depends: libmpfr-dev and libgmp-dev (Closes: #667481).
  * ada_libraries, control, rules: use dh_ada_library.

 -- Nicolas Boulenguez <nicolas.boulenguez@free.fr>  Wed, 04 Apr 2012 21:36:48 +0200

=== debian/control ===
Source: libgmpada
Section: libdevel
Priority: extra
Maintainer: Nicolas Boulenguez <nicolas.boulenguez@free.fr>
DM-Upload-Allowed: yes
Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 9),
 gnat, gnat-4.6, gprbuild (>= 2011),
 dh-ada-library,
 libgmp-dev, libmpfr-dev
Standards-Version: 3.9.3
Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.libgmpada
Vcs-Mtn: www.ada-france.org org.debian.libgmpada
Homepage: http://mtn-host.prjek.net/projects/libgmpada

Package: libgmpada3-dev
Architecture: any
Depends: ${misc:Depends}, ${ada:Depends},
 libgmp-dev, libmpfr-dev
Description: Ada binding to the GNU MultiPrecision library: development
 GMPAda allows programmers to use the GNU MultiPrecision library
 within the Ada language: unbounded integers, rationals and
 floats. Experimental support for mpfr's better float rounding is
 provided.
 .
 Install this package if you want to write programs that
 use libgmpada.

Package: libgmpada2
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Ada binding to the GNU MultiPrecision library: shared library
 GMPAda allows programmers to use the GNU MultiPrecision library
 within the Ada language: unbounded integers, rationals and
 floats. Experimental support for mpfr's better float rounding is
 provided.
 .
 This package contains the runtime shared library.

Package: libgmpada-dbg
Section: debug
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${ada:Depends}
Recommends: ${ada:Recommends}
Suggests: ${ada:Suggests}
Description: Ada binding to the GNU MultiPrecision library: debug symbols
 GMPAda allows programmers to use the GNU MultiPrecision library
 within the Ada language: unbounded integers, rationals and
 floats. Experimental support for mpfr's better float rounding is
 provided.
 .
 This package contains the runtime debug symbols.

=== debian/rules ===
#!/usr/bin/make -f

##############
# Legal stuff
##############

# Copyright (c) 2003-2009 Ludovic Brenta <lbrenta@debian.org>
# Copyright (c) 2009-2012 Nicolas Boulenguez <nicolas.boulenguez@free.fr>

# This build script is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 3 of the
# License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301
# USA

# On Debian systems, the full text of the GPL is in the file
# /usr/share/common-licenses/GPL-3.

######################
# Set some variables #
######################

include /usr/share/dpkg/default.mk
include /usr/share/ada/debian_packaging.mk

LIB_NAME := $(patsubst lib%,%,$(DEB_SOURCE))

SOVERSION := $(shell sed -n -e "s/^Package: lib$(LIB_NAME)\([[:digit:]]\+\)$$/\1/p" debian/control)
ifndef SOVERSION
  $(warning Could not guess SOVERSION from debian/control)
endif
LIB_PKG := lib$(LIB_NAME)$(SOVERSION)

DEV_PKG := $(shell sed -n -e "s/^Package: \(lib$(LIB_NAME)[[:digit:]]\+-dev\)$$/\1/p" debian/control)
ifndef DEV_PKG
  $(warning Could not guess DEV_PKG from debian/control)
endif

######################
# debhelper overrides
######################

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

binary binary-arch binary-indep build build-arch build-indep clean:
	dh $@ --with ada-library

override_dh_auto_build override_dh_auto_test: override_%:
	$* -- GPRBUILD_OPTIONS=$(BUILDER_OPTIONS) $(foreach var,\
          CFLAGS ADAFLAGS LDFLAGS SOVERSION,$(var)="$($(var))")

override_dh_auto_install:

# According to dh_installdocs(1), debian/README.Debian should be
# installed automatically, but it is not.
override_dh_installdocs:
	dh_installdocs --package=$(LIB_PKG) debian/README.Debian
	dh_installdocs --package=$(DEV_PKG) --link-doc=$(LIB_PKG) README TODO
	dh_installdocs --remaining-packages

override_dh_installexamples:
	dh_installexamples --package=$(DEV_PKG) demo/demo.adb demo/demo.gpr
	dh_installexamples --remaining-packages

override_dh_compress:
	dh_compress --package=$(DEV_PKG) \
          --exclude=.ads \
          --exclude=.adb \
          --exclude=Makefile \
          --exclude=.c \
          --exclude=.h
	dh_compress --remaining-packages

######################################################################

GET_ORIG_MTN := mtn://www.ada-france.org?net.prjek.mtn-host.libgmpada
GET_ORIG_DIR := lib$(LIB_NAME)
GET_ORIG_TGZ := lib$(LIB_NAME).tgz
GET_ORIG_TMP := lib$(LIB_NAME)-$@-XXXXXXXXXX

get-orig-source:
	TMPDIR=$$(mktemp --tmpdir --directory $(GET_ORIG_TMP)) && \
        mtn clone -d $$TMPDIR/db.mtn $(GET_ORIG_MTN) -k "" $$TMPDIR/$(GET_ORIG_DIR) && \
        (cd $$TMPDIR && tar --create --gzip --exclude="_MTN" $(GET_ORIG_DIR)) > $(GET_ORIG_TGZ) ; \
        rm -f -r $$TMPDIR
	@echo "The file $(GET_ORIG_TGZ) contains the latest Debian snapshot of upstream sources."

######################################################################

RUN_TESTS_TMP := lib$(LIB_NAME)-run-tests-XXXXXXXXXX

run-tests:
	TMPDIR=$$(mktemp --tmpdir --directory $(RUN_TESTS_TMP)) && \
        export TMPDIR && \
        (cd $$TMPDIR && sh $(CURDIR)/debian/tests/link_with_shared); \
        if test $$? = 0; then echo ok; else echo ko; fi; \
        rm -f -r $$TMPDIR

=== debian/watch ===
version=3
opts="uversionmangle=s/^/0.0./" http://mtn-host.prjek.net/projects/libgmpada/files/libgmpada-(.*)\.tar\.gz
opts="uversionmangle=s/^/0.0./" http://mtn-host.prjek.net/projects/libgmpada/files/libgmpada-(.*)\.tar\.bz2

## libgmpada 0.0.20121109

=== Makefile ===
--- 
+++ 
@@ -28,22 +28,26 @@
 
 # Use environment variables if available, this is common practice for
 # CFLAGS and LDFLAGS.
+CPPFLAGS ?=
 CFLAGS   ?= -O2
-ADAFLAGS ?= -O2
+ADAFLAGS ?= -O2 -gnatn
+# Inlining helps a lot for the thin binding.
 LDFLAGS  ?=
 
 .NOTPARALLEL:
-GPRBUILD_OPTIONS := -j$(shell getconf _NPROCESSORS_ONLN)
+GNATMAKE_OPTIONS := -j$(shell getconf _NPROCESSORS_ONLN)
 
 ifdef ALL_CHECKS
   CFLAGS += -Wall -Wextra -Wformat -Wformat-security -g
-  ADAFLAGS += -Wall -Wextra -g -gnatE -gnatQ -gnatVa -gnata -gnatf	\
-  -gnato -gnatq -gnatySdouxy
-  GPRBUILD_OPTIONS += -s -we
+  ADAFLAGS += -Wall -Wextra -g -gnataEfoqQ -gnatVa -gnatw.eH	\
+  -gnatydoSuxy
+  GNATMAKE_OPTIONS += -s -we
 endif
 
-# We want the same compiler for generate_constants.c and the library.
+# We want the same compiler for C and Ada sources.
 CC := gnatgcc
+
+LDLIBS := -lgmp -lmpfr
 
 ##############################
 # Installation configuration #
@@ -65,50 +69,50 @@
 # The static and dynamic library are installed into
 LIB_DIR := usr/lib
 
+################################
+# Make magic to replace spaces #
+################################
+comma := ,
+empty :=
+space := $(empty) $(empty)
+
 #########
 # Rules #
 #########
 
-# Function exporting a variable on the command line.
-to_X_options = $(foreach var,$(1),-X$(var)="$($(var))")
-
 build: build-dynamic build-static
 
 build-dynamic build-static: build-%: src/gmp-constants.ads
-	gprbuild $(LIB_NAME).gpr $(GPRBUILD_OPTIONS) -XKIND=$* $(call to_X_options,\
-          ADAFLAGS CFLAGS LDFLAGS SOVERSION)
-
+	gnatmake -P$(LIB_NAME).gpr $(GNATMAKE_OPTIONS) -XKIND=$*
 clean::
 	rm -f $(foreach dir,obj lib,$(foreach kind,dynamic static,build-$(dir)-$(kind)/*))
 
 src/gmp-constants.ads: generate_constants
 	./$< > $@
 clean::
-	rm -f src/gmp-constants.ads
-
-generate_constants: LDLIBS := -lgmp
-clean::
-	rm -f generate_constants
+	rm -f src/gmp-constants.ads generate_constants
 
 clean::
 	find -name "*~" -delete
 
+TEST_PROJECT := demo/demo.gpr
 test: build-static
-	gprbuild demo/demo.gpr $(GPRBUILD_OPTIONS) -XKIND=static $(call to_X_options,\
-          ADAFLAGS CFLAGS LDFLAGS)
+	gnatmake -P$(TEST_PROJECT) $(GNATMAKE_OPTIONS) -XKIND=static
 	demo/demo
-# Gmpada.gpr is found in the current directory when executing this
-# recipe, and will be found in the default system location after
-# installation.
+# LIB_NAME.gpr is found in the current directory when executing this
+# recipe, and in the default system location after installation.
+clean:: $(LIB_NAME).gpr
+# See below for an explanation of this prerequisite.
 clean::
-	gprclean -q demo/demo.gpr -XKIND=static
+	gnatclean -q -P$(TEST_PROJECT) -XKIND=static
 
 install: build
 	install --directory $(DESTDIR)/$(SRC_DIR)/$(LIB_NAME)
 	install --mode=644 src/*.ad[sb] src/*.[ch] $(DESTDIR)/$(SRC_DIR)/$(LIB_NAME)
 	install --directory $(DESTDIR)/$(GPR_DIR)
 	sed template_for_installed_project \
-          $(foreach var,LIB_NAME SRC_DIR ALI_DIR LIB_DIR,-e 's|$$($(var))|$($(var))|g') \
+          $(foreach var,LIB_NAME SRC_DIR ALI_DIR LDLIBS LIB_DIR, \
+          -e 's|$$($(var))|$(subst $(space),"$(comma) ",$($(var)))|g') \
           > $(DESTDIR)/$(GPR_DIR)/$(LIB_NAME).gpr
 	chmod 644 $(DESTDIR)/$(GPR_DIR)/$(LIB_NAME).gpr
 	install --directory $(DESTDIR)/$(ALI_DIR)/$(LIB_NAME)
@@ -126,4 +130,38 @@
 	rm -f $(DESTDIR)/$(LIB_DIR)/lib$(LIB_NAME).so.$(SOVERSION)
 	rm -f $(DESTDIR)/$(LIB_DIR)/lib$(LIB_NAME).so
 
+############################################################
+#  All that C stuff will be unnecessary with gprbuild’s mixed C/Ada
+#  project files.  For the moment, gnatmake will embed all .o files,
+#  we only have to compile them and store them in the object dir.
+
+C_SRC := $(wildcard src/*.c)
+
+C_OBJ_DYNAMIC := $(patsubst src/%.c,build-obj-dynamic/%.o,$(C_SRC))
+build-dynamic: $(C_OBJ_DYNAMIC)
+$(C_OBJ_DYNAMIC): build-obj-dynamic/%.o: src/%.c
+	$(CC) -c $(CPPFLAGS) $(CFLAGS) $< -o $@ -fPIC
+
+C_OBJ_STATIC  := $(patsubst src/%.c,build-obj-static/%.o, $(C_SRC))
+build-static: $(C_OBJ_STATIC)
+$(C_OBJ_STATIC): build-obj-static/%.o: src/%.c
+	$(CC) -c $(CPPFLAGS) $(CFLAGS) $< -o $@
+
+######################################################################
+# gnatmake 4.4 does not handle External_As_List, so we emulate it with
+# a template instead of passing the options with -X.
+
+build-dynamic build-static: $(LIB_NAME).gpr
+# This is a prerequisite for clean too, but it must bea added before
+# gnatclean is called.
+
+$(LIB_NAME).gpr: %.gpr: %.gpr.sed
+	sed $< \
+	 $(foreach var,ADAFLAGS CFLAGS CPPFLAGS LDFLAGS LDLIBS SOVERSION, \
+	   -e 's/$(var)/$(subst $(space),"$(comma) ",$($(var)))/') \
+	 > $@
+
+clean::
+	rm -f $(LIB_NAME).gpr
+
 .PHONY: build build-dynamic build-static clean install test uninstall

=== debian/changelog ===
libgmpada (0.0.20121109-1ubuntu2) raring; urgency=low

  * debian/tests/link_with_shared: Drop set -v option and redirect gnatmake
    stderr to stdout, to avoid writing stuff to stderr. Fixes autopkgtest
    failure.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Mon, 18 Mar 2013 10:51:15 +0100

libgmpada (0.0.20121109-1ubuntu1) raring; urgency=low

  * pass --no-as-needed to build to fix failure

 -- Julian Taylor <jtaylor@ubuntu.com>  Sat, 09 Mar 2013 12:45:47 +0100

libgmpada (0.0.20121109-1) unstable; urgency=low

  * New upstream release (no patches needed anymore).
  * control: libgmpada3-dev -> libgmpada4-dev, with Breaks/Replaces,
    due to debian-ada-policy.
    XS-Testsuite: autopkgtest (Closes: #692663).
    Maintainer, DM-Upload-Allowed: I am a DD.
    Build-Depends: gprbuild is not needed anymore
  * copyright: GPL2+ -> GPL3+.
  * watch: gz -> bzip2.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 08 Nov 2012 16:17:00 +0100

libgmpada (0.0.20120331-2) unstable; urgency=low

  * Inherit hardening CPPFLAGS.

 -- Nicolas Boulenguez <nicolas.boulenguez@free.fr>  Sat, 07 Jul 2012 21:37:49 +0200

=== debian/control ===
--- 
+++ 
@@ -1,21 +1,24 @@
 Source: libgmpada
 Section: libdevel
 Priority: extra
-Maintainer: Nicolas Boulenguez <nicolas.boulenguez@free.fr>
-DM-Upload-Allowed: yes
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Nicolas Boulenguez <nicolas@debian.org>
 Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 9),
- gnat, gnat-4.6, gprbuild (>= 2011),
- dh-ada-library,
+ gnat, gnat-4.6,
+ dh-ada-library (>= 5),
  libgmp-dev, libmpfr-dev
 Standards-Version: 3.9.3
 Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.libgmpada
 Vcs-Mtn: www.ada-france.org org.debian.libgmpada
 Homepage: http://mtn-host.prjek.net/projects/libgmpada
+XS-Testsuite: autopkgtest
 
-Package: libgmpada3-dev
+Package: libgmpada4-dev
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends},
  libgmp-dev, libmpfr-dev
+Breaks: libgmpada3-dev
+Replaces: libgmpada3-dev
 Description: Ada binding to the GNU MultiPrecision library: development
  GMPAda allows programmers to use the GNU MultiPrecision library
  within the Ada language: unbounded integers, rationals and

=== debian/rules ===
--- 
+++ 
@@ -29,14 +29,20 @@
 # Set some variables #
 ######################
 
+# found no way to fix the build otherwise (see #702632)
+DEB_LDFLAGS_MAINT_PREPEND = -Wl,--no-as-needed
 include /usr/share/dpkg/default.mk
 include /usr/share/ada/debian_packaging.mk
+
+ADAFLAGS += -gnatn
+# This is very useful for the thin binding.
 
 LIB_NAME := $(patsubst lib%,%,$(DEB_SOURCE))
 
 SOVERSION := $(shell sed -n -e "s/^Package: lib$(LIB_NAME)\([[:digit:]]\+\)$$/\1/p" debian/control)
 ifndef SOVERSION
   $(warning Could not guess SOVERSION from debian/control)
+  # Not error. Policy defines targets that may be run from outside build dir.
 endif
 LIB_PKG := lib$(LIB_NAME)$(SOVERSION)
 
@@ -56,9 +62,11 @@
 	dh $@ --with ada-library
 
 override_dh_auto_build override_dh_auto_test: override_%:
-	$* -- GPRBUILD_OPTIONS=$(BUILDER_OPTIONS) $(foreach var,\
-          CFLAGS ADAFLAGS LDFLAGS SOVERSION,$(var)="$($(var))")
+	$* -- $(foreach var,\
+          ADAFLAGS CFLAGS CPPFLAGS LDFLAGS SOVERSION,$(var)="$($(var))") \
+          GNATMAKE_OPTIONS="$(BUILDER_OPTIONS)"
 
+# Ignore these targets from upstream Makefile.
 override_dh_auto_install:
 
 # According to dh_installdocs(1), debian/README.Debian should be

=== debian/watch ===
version=3
opts="uversionmangle=s/^/0.0./" http://mtn-host.prjek.net/projects/libgmpada/files/libgmpada-(.*)\.tar\.bz2

## libgmpada 0.0.20131223

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #    GMPAda, binding to the Ada Language for the GNU MultiPrecision library.
-#    Copyright (C) 2007-2012 Nicolas Boulenguez <nicolas.boulenguez@free.fr>
+#    Copyright (C) 2007-2013 Nicolas Boulenguez <nicolas.boulenguez@free.fr>
 #
 #    This program is free software: you can redistribute it and/or modify
 #    it under the terms of the GNU General Public License as published by
@@ -45,7 +45,7 @@
 endif
 
 # We want the same compiler for C and Ada sources.
-CC := gnatgcc
+CC := $(shell gnatmake --version | sed -n '1 s/GNATMAKE /gcc-/p')
 
 LDLIBS := -lgmp -lmpfr

=== debian/changelog ===
libgmpada (0.0.20131223-4) unstable; urgency=medium

  * Touch generated sources for deterministic ALI files and tar headers.
  * Standards-Version: 3.9.6 (no changes).

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 04 May 2015 14:47:22 +0200

libgmpada (0.0.20131223-3) unstable; urgency=medium

  * Pass CC to make, circumventing wrong autodetection. Closes: #768706.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 09 Nov 2014 14:18:38 +0100

libgmpada (0.0.20131223-2) unstable; urgency=medium

  * Migrate to gnat-4.9.
    Rename library and -dev package according to Ada policy.
  * move armored upstream signature to upstream/.
  * rules: run-tests target obsoleted by sadt from devscripts.

 -- Nicolas Boulenguez <nicolas@debian.org>  Fri, 02 May 2014 04:21:56 +0200

libgmpada (0.0.20131223-1) unstable; urgency=medium

  * New upstream release.
  * Standards-Version: 3.9.4 (no changes).
  * watch, upstream-signing-key.pgp added.

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 23 Dec 2013 05:40:19 +0100

libgmpada (0.0.20121109-3) unstable; urgency=low

  * tests: valid test names may not contain underscores.
  * rules: updated run-tests target.
  * remove any /usr/share/doc/pkg symlink, they cause maintenance problems.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 24 Aug 2013 00:16:17 +0200

libgmpada (0.0.20121109-2) unstable; urgency=low

  * tests/link_with_shared: avoid gnatmake printing on stderr.
    Closes: #702634, #703310.
    rules: run-tests target updated to emulate recent autopkgtest.
  * source/options: deleted, so that dpkg uses the default compression.
  * README.debian: why lintian hardening-no-fortify-functions may be ignored.
  * control: Build-Depends: gnat-4.6 >= 4.6.4, so that gnatlink handles
    --as-needed linker flag properly. Closes: #702632.
  * control: Standards-Version: 3.9.4.
  * Updated copyrights.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 10 Mar 2013 20:04:13 +0100

=== debian/control ===
--- 
+++ 
@@ -1,24 +1,23 @@
 Source: libgmpada
 Section: libdevel
 Priority: extra
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Nicolas Boulenguez <nicolas@debian.org>
+Maintainer: Nicolas Boulenguez <nicolas@debian.org>
 Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 9),
- gnat, gnat-4.6,
- dh-ada-library (>= 5),
+ gnat, gnat-4.9,
+ dh-ada-library (>= 5.4),
  libgmp-dev, libmpfr-dev
-Standards-Version: 3.9.3
+# dpkg-dev >= 1.16.1 provides /usr/share/dpkg/default.mk.
+# dh-ada-library >= 5.4 stops linking doc directories.
+Standards-Version: 3.9.6
 Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.libgmpada
 Vcs-Mtn: www.ada-france.org org.debian.libgmpada
 Homepage: http://mtn-host.prjek.net/projects/libgmpada
 XS-Testsuite: autopkgtest
 
-Package: libgmpada4-dev
+Package: libgmpada5-dev
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends},
  libgmp-dev, libmpfr-dev
-Breaks: libgmpada3-dev
-Replaces: libgmpada3-dev
 Description: Ada binding to the GNU MultiPrecision library: development
  GMPAda allows programmers to use the GNU MultiPrecision library
  within the Ada language: unbounded integers, rationals and
@@ -28,7 +27,7 @@
  Install this package if you want to write programs that
  use libgmpada.
 
-Package: libgmpada2
+Package: libgmpada3
 Section: libs
 Architecture: any
 Multi-Arch: same

=== debian/rules ===
#!/usr/bin/make -f

##############
# Legal stuff
##############

# Copyright (c) 2003-2009 Ludovic Brenta <lbrenta@debian.org>
# Copyright (c) 2009-2015 Nicolas Boulenguez <nicolas@debian.org>

# This build script is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 3 of the
# License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# On Debian systems, the full text of the GPL is in the file
# /usr/share/common-licenses/GPL-3.

######################
# Set some variables #
######################

include /usr/share/dpkg/default.mk
include /usr/share/ada/debian_packaging.mk

DEB_DATE_RFC_2822 := $(shell dpkg-parsechangelog -S date)
DEB_DATE_RFC_3339 := $(shell date "+%F %T" -d "$(DEB_DATE_RFC_2822)")

ADAFLAGS += -gnatn
# This is very useful for the thin binding.

LIB_NAME := $(patsubst lib%,%,$(DEB_SOURCE))

SOVERSION := $(shell sed -n -e "s/^Package: lib$(LIB_NAME)\([[:digit:]]\+\)$$/\1/p" debian/control)
ifndef SOVERSION
  $(warning Could not guess SOVERSION from debian/control)
  # Not error. Policy defines targets that may be run from outside build dir.
endif

######################
# debhelper overrides
######################

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

POLICY_TARGETS := binary binary-arch binary-indep build build-arch \
  build-indep clean
.PHONY: $(POLICY_TARGETS)
$(POLICY_TARGETS):
	dh $@ --with ada-library

override_dh_auto_build override_dh_auto_test: override_%:
 # Ensure that generated sources have been produced.
	dh_auto_build -- src/gmp-constants.ads $(foreach var,\
          ADAFLAGS CC CFLAGS CPPFLAGS LDFLAGS SOVERSION,$(var)="$($(var))") \
          GNATMAKE_OPTIONS="$(BUILDER_OPTIONS)"
 # Touch generated sources for deterministic ALI files and tar headers.
	find . -depth -newermt '$(DEB_DATE_RFC_3339)' -print0 | \
	  xargs -0r touch --no-dereference --date='$(DEB_DATE_RFC_3339)'
 # CC is passed from debian_packaging.mk to Makefile to circumvent #768706.
 # Upstream should autodetect it correctly after 0.0.20131223.
	$* -- $(foreach var,\
          ADAFLAGS CC CFLAGS CPPFLAGS LDFLAGS SOVERSION,$(var)="$($(var))") \
          GNATMAKE_OPTIONS="$(BUILDER_OPTIONS)"

# Ignore these targets from upstream Makefile.
override_dh_auto_install:

override_dh_compress:
	dh_compress --all \
          --exclude=.ads \
          --exclude=.adb \
          --exclude=Makefile \
          --exclude=.c \
          --exclude=.h

######################################################################

GET_ORIG_MTN := mtn://www.ada-france.org?net.prjek.mtn-host.libgmpada
GET_ORIG_DIR := lib$(LIB_NAME)
GET_ORIG_TGZ := lib$(LIB_NAME).tgz
GET_ORIG_TMP := lib$(LIB_NAME)-get-orig-source-XXXXXXXXXX

get-orig-source:
	TMPDIR=$$(mktemp --tmpdir --directory $(GET_ORIG_TMP)) && \
        mtn clone -d $$TMPDIR/db.mtn $(GET_ORIG_MTN) -k "" $$TMPDIR/$(GET_ORIG_DIR) && \
        (cd $$TMPDIR && tar --create --gzip --exclude="_MTN" $(GET_ORIG_DIR)) > $(GET_ORIG_TGZ) ; \
        rm -f -r $$TMPDIR
	@echo "The file $(GET_ORIG_TGZ) contains the latest Debian snapshot of upstream sources."

=== debian/watch ===
version=3
opts=uversionmangle=s/^/0.0./,pgpsigurlmangle=s/$/.asc/ \
http://mtn-host.prjek.net/projects/libgmpada/files/libgmpada-(.*)\.tar\.bz2

## libgmpada 1.0

=== Makefile ===
#    GMPAda, binding to the Ada Language for the GNU MultiPrecision library.
#    Copyright (C) 2007-2015 Nicolas Boulenguez <nicolas.boulenguez@free.fr>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

########################
# Global configuration #
########################

LIB_NAME := gmpada

SOVERSION := 2

################################
# Build and test configuration #
################################

# Use environment variables if available, this is common practice for
# CFLAGS and LDFLAGS.
CPPFLAGS ?=
CFLAGS   ?= -O2
ADAFLAGS ?= -O2 -gnatn
# Inlining helps a lot for the thin binding.
LDFLAGS  ?=

.NOTPARALLEL:
GNATMAKE_OPTIONS := -j$(shell getconf _NPROCESSORS_ONLN)

ifdef ALL_CHECKS
  CFLAGS += -Wall -Wextra -Wformat -Wformat-security -g
  ADAFLAGS += -Wall -Wextra -g -gnataEfoqQ -gnatVa -gnatw.eH.Y \
  -gnatyBdIoOSuxy -fstack-check -Wunused -Wuninitialized
  LDFLAGS += -Wl,--as-needed -Wl,-z,defs
  GNATMAKE_OPTIONS += -s -v -we
endif

# We want the same compiler for C and Ada sources.
# Accept both gcc-4.9 and gcc-5.
CC := $(notdir $(shell which `gnatmake --version \
  | sed '1{s/^GNATMAKE \(\([0-9]\+\)\.[0-9]\+\).*/gcc-\1 gcc-\2/;q}'`))
ifneq ($(words $(CC)),1)
 $(error Failed to set CC from gnatmake output.)
endif

LDLIBS := -lgmp -lmpfr

##############################
# Installation configuration #
##############################

# Each of the following path should be prefixed with
DESTDIR :=

# The sources files are installed into a LIB_NAME subdirectory of
SRC_DIR := usr/share/ada/adainclude

# A LIB_NAME.gpr project convenient for library usage is installed into
GPR_DIR := usr/share/ada/adainclude
# The content of this file ignores DESTDIR.

# The GNAT ALI files are installed into a LIB_NAME subdirectory of
ALI_DIR := usr/lib/ada/adalib

# The static and dynamic library are installed into
LIB_DIR := usr/lib

#########
# Rules #
#########

ADA_SOURCES     := $(wildcard src/*.ad[bs]) src/gmp-constants.ads
C_SOURCES       := $(wildcard src/*.c)
C_OBJ_DYNAMIC   := $(patsubst src/%.c,obj-dynamic/%.o,$(C_SOURCES))
C_OBJ_STATIC    := $(patsubst src/%.c,obj-static/%.o, $(C_SOURCES))

# Default target is:
.PHONY: build
build: obj/lib$(LIB_NAME).so.$(SOVERSION) \
       obj/lib$(LIB_NAME).a \
       obj/$(LIB_NAME).gpr

obj/lib$(LIB_NAME).so.$(SOVERSION): $(ADA_SOURCES) $(C_OBJ_DYNAMIC)
	gnatmake -c src/*.ad[bs] -D obj-dynamic $(GNATMAKE_OPTIONS) \
          -cargs $(ADAFLAGS) -fPIC
	gcc -shared -o $@ -Wl,-soname,lib$(LIB_NAME).so.$(SOVERSION) \
          obj-dynamic/*.o $(LDFLAGS) $(LDLIBS) -lgnat-$(subst gcc-,,$(CC))

obj/lib$(LIB_NAME).a: $(ADA_SOURCES) $(C_OBJ_STATIC)
	gnatmake -c src/*.ad[bs] -D obj-static $(GNATMAKE_OPTIONS) \
          -cargs $(ADAFLAGS)
	ar cr $@ obj-static/*.o
	ranlib $@

$(C_OBJ_DYNAMIC): obj-dynamic/%.o: src/%.c
	$(CC) -c $(CPPFLAGS) $(CFLAGS) $< -o $@ -fPIC

$(C_OBJ_STATIC): obj-static/%.o: src/%.c
	$(CC) -c $(CPPFLAGS) $(CFLAGS) $< -o $@

obj/$(LIB_NAME).gpr: template_for_installed_project
	sed \
          -e s/@LIB_NAME@/$(LIB_NAME)/ \
          -e '/@LDLIBS@/{s||$(patsubst %,"%",$(LDLIBS))|;s/" "/", "/g}' \
          $(foreach d,SRC ALI LIB \
          ,-e "s|@$(d)_DIR@|`realpath -m $($(d)_DIR) --relative-to=$(GPR_DIR)`|") \
          $< > $@

src/gmp-constants.ads: obj/generate_constants
	$< > $@
  # If caller has set SOURCE_DATE_EPOCH, avoid generating
  # unreproducible timestamps in ALI files.
  ifdef SOURCE_DATE_EPOCH
	touch -d "@$(SOURCE_DATE_EPOCH)" $@
  endif

obj/generate_constants: generate_constants.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) $< $(LDLIBS) -o $@

clean::
	rm -f src/gmp-constants.ads obj/* obj-dynamic/* obj-static/*
	find -name "*~" -delete

######################################################################
.PHONY: test
test:
	mkdir -p demo-install
	$(MAKE) install DESTDIR=demo-install

	gnatmake demo/demo.adb -o demo/obj-dynamic/demo -D demo/obj-dynamic $(GNATMAKE_OPTIONS) \
          -aIdemo-install/$(SRC_DIR)/$(LIB_NAME) \
          -aOdemo-install/$(ALI_DIR)/$(LIB_NAME) \
          -cargs $(ADAFLAGS) \
          -largs $(LDFLAGS) -Ldemo-install/$(LIB_DIR) -l$(LIB_NAME) $(LDLIBS)
	LD_LIBRARY_PATH=demo-install/$(LIB_DIR) demo/obj-dynamic/demo

  # This test will fail once gnatmake drops project support, but for
  # now we can test projects without gprbuild.
	gnatmake -aPdemo-install/$(GPR_DIR) -Pdemo/demo.gpr
	LD_LIBRARY_PATH=demo-install/$(LIB_DIR) demo/obj-project/demo

	gnatmake demo/demo.adb -o demo/obj-static/demo -D demo/obj-static $(GNATMAKE_OPTIONS) \
          -aIdemo-install/$(SRC_DIR)/$(LIB_NAME) \
          -aOdemo-install/$(ALI_DIR)/$(LIB_NAME) \
          -cargs $(ADAFLAGS) \
          -largs $(LDFLAGS) demo-install/$(LIB_DIR)/lib$(LIB_NAME).a $(LDLIBS)
	demo/obj-static/demo

	$(MAKE) uninstall DESTDIR=demo-install
	test `find demo-install -type f | wc -l` = 0

clean::
	rm -f demo/obj-dynamic/* demo/obj-project/* demo/obj-static/*
	rm -fr demo-install

######################################################################
.PHONY: install
install: build
	install --directory $(DESTDIR)/$(SRC_DIR)/$(LIB_NAME)
	install --mode=644 src/*.ad[sb] src/*.[ch] $(DESTDIR)/$(SRC_DIR)/$(LIB_NAME)
	install --directory $(DESTDIR)/$(GPR_DIR)
	install --mode=644 obj/$(LIB_NAME).gpr $(DESTDIR)/$(GPR_DIR)
	install --directory $(DESTDIR)/$(ALI_DIR)/$(LIB_NAME)
	install --mode=444 obj-dynamic/*.ali $(DESTDIR)/$(ALI_DIR)/$(LIB_NAME)
	install --directory $(DESTDIR)/$(LIB_DIR)
	install --mode=644 obj/lib$(LIB_NAME).a $(DESTDIR)/$(LIB_DIR)
	install --mode=644 obj/lib$(LIB_NAME).so.$(SOVERSION) $(DESTDIR)/$(LIB_DIR)
	ln --force --symbolic lib$(LIB_NAME).so.$(SOVERSION) $(DESTDIR)/$(LIB_DIR)/lib$(LIB_NAME).so

.PHONY: uninstall
uninstall:
	rm -rf $(DESTDIR)/$(SRC_DIR)/$(LIB_NAME)
	rm -f $(DESTDIR)/$(GPR_DIR)/$(LIB_NAME).gpr
	rm -rf $(DESTDIR)/$(ALI_DIR)/$(LIB_NAME)
	rm -f $(DESTDIR)/$(LIB_DIR)/lib$(LIB_NAME).a
	rm -f $(DESTDIR)/$(LIB_DIR)/lib$(LIB_NAME).so.$(SOVERSION)
	rm -f $(DESTDIR)/$(LIB_DIR)/lib$(LIB_NAME).so

######################################################################
.PHONY: clean

=== debian/changelog ===
libgmpada (1.0-3) unstable; urgency=medium

  * Previous patch does not fix the FTBFS and uses obsolete -aL option.
    Copy the objects in ALI directory instead.
  * Pass build flags to tests, especially activate assertions.

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 16 May 2016 17:36:00 +0200

libgmpada (1.0-2) unstable; urgency=medium

  * patches/gnatmake-al-not-ao-alidir.diff: changing gnatmake options to
    work around a segfault in a test with gnat-6 on kfreebsd-amd64.

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 16 May 2016 02:17:55 +0200

libgmpada (1.0-1) unstable; urgency=medium

  * New upstream release and website.
    Update watch, control/Homepage and copyright/Upstream-Contact.
    Drop get-orig-source target.
  * Build with gnat-6 and all hardening flags. Closes: #822775.
    Rename lib and -dev packages per Ada policy.
  * fake.gpr: new for dh-ada-library, no build project anymore.
  * Remove obsolete preinst scripts.
  * Replace manual -dbg packages with automatic -dbgsym.
  * Standards-Version: 3.9.8 (no changes).

 -- Nicolas Boulenguez <nicolas@debian.org>  Wed, 27 Apr 2016 18:22:01 +0200

=== debian/control ===
Source: libgmpada
Section: libdevel
Priority: extra
Maintainer: Nicolas Boulenguez <nicolas@debian.org>
Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 9),
 gnat, gnat-6,
 dh-ada-library (>= 6.7),
# dh-ada-library >= 6.7 stops requiring -dbg packages.
 libgmp-dev, libmpfr-dev
# dpkg-dev >= 1.16.1 provides /usr/share/dpkg/default.mk.
Standards-Version: 3.9.8
Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.libgmpada
Vcs-Mtn: www.ada-france.org org.debian.libgmpada
Homepage: http://nicolas.boulenguez.free.fr

Package: libgmpada6-dev
Architecture: any
Depends: ${misc:Depends}, ${ada:Depends},
 libgmp-dev, libmpfr-dev
Description: Ada binding to the GNU MultiPrecision library: development
 GMPAda allows programmers to use the GNU MultiPrecision library
 within the Ada language: unbounded integers, rationals and
 floats. Experimental support for mpfr's better float rounding is
 provided.
 .
 Install this package if you want to write programs that
 use libgmpada.

Package: libgmpada4
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Ada binding to the GNU MultiPrecision library: shared library
 GMPAda allows programmers to use the GNU MultiPrecision library
 within the Ada language: unbounded integers, rationals and
 floats. Experimental support for mpfr's better float rounding is
 provided.
 .
 This package contains the runtime shared library.

=== debian/rules ===
#!/usr/bin/make -f

##############
# Legal stuff
##############

# Copyright (c) 2003-2009 Ludovic Brenta <lbrenta@debian.org>
# Copyright (c) 2009-2016 Nicolas Boulenguez <nicolas@debian.org>

# This build script is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 3 of the
# License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# On Debian systems, the full text of the GPL is in the file
# /usr/share/common-licenses/GPL-3.

######################
# Set some variables #
######################

DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie
include /usr/share/dpkg/default.mk
include /usr/share/ada/debian_packaging*.mk

ADAFLAGS += -gnatn
# This is very useful for the thin binding.

LIB_NAME := $(patsubst lib%,%,$(DEB_SOURCE))

SOVERSION := $(shell sed -n -e "s/^Package: lib$(LIB_NAME)\([[:digit:]]\+\)$$/\1/p" debian/control)
ifndef SOVERSION
  $(warning Could not guess SOVERSION from debian/control)
  # Not error. Policy defines targets that may be run from outside build dir.
endif

######################
# debhelper overrides
######################

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

POLICY_TARGETS := binary binary-arch binary-indep build build-arch \
  build-indep clean
.PHONY: $(POLICY_TARGETS)
$(POLICY_TARGETS):
	dh $@ --with ada-library

OPTIONS_FOR_UPSTREAM_MAKE = $(foreach var,\
 ADAFLAGS CFLAGS CPPFLAGS LDFLAGS SOVERSION,$(var)="$($(var))") \
 GNATMAKE_OPTIONS="$(BUILDER_OPTIONS)"

.PHONY: override_dh_auto_build override_dh_auto_test
override_dh_auto_build override_dh_auto_test: override_%:
	$* -- $(OPTIONS_FOR_UPSTREAM_MAKE)
override_dh_auto_test: ADAFLAGS += -gnata

# Ignore this target from upstream Makefile.
.PHONY: override_dh_auto_install

.PHONY: override_dh_ada_library
override_dh_ada_library:
	dh_ada_library \
          LDLIBS="`sed -n '/^LDLIBS := /{s///;p;q}' Makefile`" debian/fake.gpr

.PHONY: override_dh_compress
override_dh_compress:
	dh_compress --all \
          --exclude=.ads \
          --exclude=.adb \
          --exclude=Makefile \
          --exclude=.c \
          --exclude=.h

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.asc/ \
  http://nicolas.boulenguez.free.fr \
  libgmpada-(.*)\.tar\.xz
